#include "libcmd.h"

/*! retourne un tableau de pointeurs contenant les noms des fonctions de ce 
 * fichier, le dernier lment du tableau tant NULL
 */
char ** getPlugins(void)
{
    char ** tab = NULL;

    tab = malloc(sizeof(char *)*3);
    if ( tab == NULL ) {
	perror("malloc");
	return NULL;
    }

    tab[0] = malloc(10);
    if ( tab[0] == NULL ) {
	perror("malloc");
	free(tab);
	return NULL;
    }

    tab[1] = malloc(12);
    if ( tab[1] == NULL ) {
	perror("malloc");
	free(tab[0]);
	free(tab);
	return NULL;
    }

    strcpy(tab[0],"tocommand");
    strcpy(tab[1],"fromcommand");

    tab[2] = NULL;

    return tab;
}

/*! xcute une commande shell argv[1] avec ses arguments en lui passant sur
 * l'entre standard la liste en tte de pile sous forme de lignes
 */
int tocommand(pile * p, int argc, char ** argv)
{
    FILE * tocmd = NULL;
    int res, i, len = 0;
    liste l = (*p)->l;
    char * cmd = NULL;

    for ( i=1 ; i < argc ; i++ )
	len += strlen(argv[i])+1;
    cmd = malloc(len+1);
    if ( cmd == NULL ) {
	perror("malloc");
	return 0;
    }

    strcpy(cmd,argv[1]);
    for ( i=2 ; i < argc ; i++ ) {
	strcat(cmd," ");
	strcat(cmd,argv[i]);
    }

    if ( (tocmd = popen(cmd,"w")) == NULL ) {
	free(cmd);
	perror("popen");
	return 0;
    }
    free(cmd);

    while ( l != NULL ) {
	if ( fprintf(tocmd, "%s\n", l->m) < 0 ) {
	    perror("fprintf");
	    return 0;
	}
	l = l->suiv;
    }

    res = pclose(tocmd);
    if ( res == -1 ) {
	perror("pclose");
	return 0;
    }

    return !res;
}

/*! excute une commande shell argv[1] avec ses arguments et place en sommet de
 * pile la liste des lignes retournes par la commande.
 */
int fromcommand(pile * p, int argc, char ** argv)
{
    FILE * fromcmd = NULL;
    int res;
    liste l = NULL;
    char * ligne = NULL, * cmd = NULL;
    int tbuf = 0, len=0, i;

    for ( i=1 ; i < argc ; i++ )
	len += strlen(argv[i])+1;
    cmd = malloc(len+1);
    if ( cmd == NULL ) {
	perror("malloc");
	return 0;
    }

    strcpy(cmd,argv[1]);
    for ( i=2 ; i < argc ; i++ ) {
	strcat(cmd," ");
	strcat(cmd,argv[i]);
    }

    if ( (fromcmd = popen(cmd, "r")) == NULL ) {
	free(cmd);
	perror("popen");
	return 0;
    }
    free(cmd);

    while ( (len = getline(&ligne,&tbuf,fromcmd)) != -1 ) {
	ligne[len-1] = 0; // On retire \n
	ajoute(&l, ligne);
    }

    empile(l,p);

    free(ligne);

    res = pclose(fromcmd);
    if ( res == -1 ) {
	perror("pclose");
	return 0;
    }
    
    return !res;
}
