#include "libdir.h"

/*! retourne un tableau de pointeurs contenant les noms des fonctions de ce 
 * fichier, le dernier lment du tableau tant NULL
 */
char ** getPlugins(void)
{ 
    char ** tab = NULL;
    
    tab = malloc(sizeof(char *)*3);
    if ( tab == NULL ) {
	perror("malloc");
	return NULL;
    }

    tab[0] = malloc(4);
    if ( tab[0] == NULL ) {
	perror("malloc");
	free(tab);
	return NULL;
    }

    tab[1] = malloc(7);
    if ( tab[1] == NULL ) {
	perror("malloc");
	free(tab[0]);
	free(tab);
	return NULL;
    }

    strcpy(tab[0],"dir");
    strcpy(tab[1],"recdir");

    tab[2] = NULL;

    return tab;
}

/* !retire le sommet de la pile,
 * le considre comme une liste de noms de rpertoire 
 * et qui retourne la liste des noms de fichiers de ces rpertoires
 */

int dir(pile *p,int argc,char **argv)
{
  if(*p == NULL)
    return 0;

  DIR *dir;
  struct dirent *dirent=NULL;


  liste l;
  l=depile(p);

  while(l != NULL)
    {
      dir = opendir(l->m);
      if(dir == NULL)
	{
	  perror("opendir");
	  
	}
      if(dir != NULL)
	{
	  while((dirent=readdir(dir)) != NULL)
	    {
	      printf("%s\n",dirent->d_name);
	    }
	  
	  if( -1 == closedir(dir))
	    {
	      perror("closedir");
	      
	    }
	}
      
      l=l->suiv;
    }
  detruireliste(l);
  return 1;
}




/*! effectue la mme chose que dir(), mais rcursivement
 */
int recdir(pile * p, int argc, char **argv)
{

  if(*p == NULL)
    return 0;

  char * cmd = NULL;
  liste l;
  l=depile(p);

  while(l != NULL)
    {
      cmd = malloc(5+strlen(l->m)+1);
      strcpy(cmd,"find ");
      strcat(cmd,l->m);   
       system(cmd); // pas mieux...
       free(cmd);
       
      
     
      l=l->suiv;
    }
  detruireliste(l);
  return 1;

}
