#include "libgestion.h"

/*! retourne un tableau de pointeurs contenant les noms des fonctions de ce 
 * fichier, le dernier lment du tableau tant NULL
 */
char ** getPlugins(void)
{
    char ** tab = NULL;

    tab = malloc(sizeof(char *) * 5);
    if ( tab == NULL ) {
	perror("malloc");
	return NULL;
    }

    tab[0] = malloc(5);
    if ( tab[0] == NULL ) {
	perror("malloc");
	free(tab);
	return NULL;
    }
    strcpy(tab[0],"list");

    tab[1] = malloc(4);
    if ( tab[1] == NULL ) {
	perror("malloc");
	free(tab[0]);
	free(tab);
	return NULL;
    }
    strcpy(tab[1], "dup");

    tab[2] = malloc(7);
    if ( tab[2] == NULL ) {
	perror("malloc");
	free(tab[0]);
	free(tab[1]);
	free(tab);
	return NULL;
    }
    strcpy(tab[2],"concat");

    tab[3] = malloc(5);
    if ( tab[3] == NULL ) {
	perror("malloc");
	free(tab[2]);
	free(tab[0]);
	free(tab[1]);
	free(tab);
	return NULL;
    }
    strcpy(tab[3], "file");
    
    return tab;
}


/*! ajoute en sommet de pile la liste de ces arguments
 */
int list(pile * p,int argc,char ** argv)
{
  int i;

  liste l=NULL;

  for(i=1;i < argc;i++)
    ajoute(&l,argv[i]);
  
  empile(l,p);

  return 1;
}


liste dupliste(liste l)
{
  if(l == NULL)
    return NULL;

  liste tmp;
  tmp=dupliste(l->suiv);
  ajoute(&tmp,l->m);
  return tmp;
}


/*! duplique la liste en sommet de pile et replace la liste et sa copie en sommets de pile
 */
int dup(pile * p,int argc,char ** argv)
{
  if(*p == NULL)
    return 0;
  
  empile(dupliste((*p)->l),p);
  
  return 1;
}



/*! retire les deux listes en sommet de pile,
 * les concatne  avec la liste en sommet de pile au dbut 
 * et replace le rsultat en sommet de pile
 */

int concat(pile *p,int argc,char **argv)
{
  liste l1;
  liste l2;


  l1=depile(p);
  l2=depile(p);
  
  
  
  if(l1 != NULL )
    {
      liste parcours;
      parcours=l1;
      
      while(parcours->suiv != NULL)
	parcours = parcours->suiv;
      
      parcours->suiv=l2;
      
      empile(l1,p);
      
      
    }
  return 1;
  
}

/*! lit le fichier de nom argv[1]
 * et ajoute en sommet de pile la liste des lignes du fichier
 */

int file(pile *p,int argc,char **argv)
{

  if(argc != 2)
    return 0;

  FILE *fich;
  fich=fopen(argv[1],"r");
  if(fich == NULL)
    {
      perror("fopen");
      return 0;
    }

  char *ligne=NULL;
  int taille_buf=0;
  int len;
  liste l=NULL;

  while( (len = getline(&ligne,&taille_buf,fich)) != -1)
    {
      ligne[len-1]=0;
      ajoute(&l,ligne);
    }

  free(ligne);

  empile(l,p);
  fclose(fich);

 return 1;
}



