#include "libgrep.h"

/*! retourne un tableau de pointeurs contenant les noms des fonctions de ce 
 * fichier, le dernier lment du tableau tant NULL
 */
char ** getPlugins(void)
{
    char ** tab;

    tab = malloc(sizeof(char *)*2);
    if ( tab == NULL ) {
	perror("malloc");
	return NULL;
    }

    tab[0] = malloc(5);
    if ( tab[0] == NULL ) {
	free(tab);
	perror("malloc");
	return NULL;
    }

    strcpy(tab[0], "grep");

    tab[1] = NULL;

    return tab;
}

/*! efface tous les lments de la liste en tte de pile correspondant 
 * l'expression rationnelle argv[1]
 */
int grep(pile * p, int argc, char ** argv)
{
    if ( argc < 2 || *p == NULL )
	return 0;
    
    regex_t preg;
    liste parcours = (*p)->l;
    liste match = NULL;

    if ( regcomp(&preg,argv[1],REG_EXTENDED) != 0 ) {
	fprintf(stderr,"Erreur  la compilation de %s\n",argv[1]);
	return 0;
    }

    // Dtection
    while ( parcours != NULL ) {
	if ( regexec(&preg, parcours->m, 0, NULL, 0) == 0 )
	    ajoute(&match, parcours->m);
	parcours = parcours->suiv;
    }

    // Suppression
    parcours = match;
    while ( parcours != NULL ) {
	suppression(&((*p)->l), parcours->m);
	parcours = parcours->suiv;
    }
    detruireliste(match);

    regfree(&preg);
    
    return 1;
}
