#include"liste.h"

/*! alloue l'espace memoire pour une cellule
 * \return un pointeur sur une cellule de liste
 */
liste init(char * mot)
{
  liste tmp=NULL;

  tmp=(liste)malloc(sizeof(cel));
  if(tmp == NULL)
    {
      perror("malloc");
      return NULL;
    }

  tmp->m=(char *)calloc(strlen(mot)+1,sizeof(char));
  if(tmp->m == NULL)
    {
      perror("malloc");
      free(tmp);
      return NULL;
    }

  strcpy(tmp->m,mot);
  tmp->suiv = NULL;
  return tmp;
}

/*! ajoute un mot dans la liste
 * \return NULL en cas d'erreur
 */
liste ajoute(liste *l,char *m)
{
  liste tmp;
  tmp=init(m);

  if(tmp == NULL)
    return NULL;
 
  tmp->suiv=*l;
  *l=tmp;
  
  return tmp;
}
/*! libere l'espace memoire engrendrer pour la creation la liste */
void detruireliste(liste l)
{
  if(l == NULL)
    return ;

  detruireliste(l->suiv);
  free(l->m);
  free(l);
}

/*! affiche les mots de la liste */
void affiche(liste l)
{
  while(l != NULL)
    {
      printf("%s \n",l->m);
      l=l->suiv;
    }
}

/*! supprime le mot de la liste 
 * \return NULL en cas d'erreur
 */
liste suppression(liste *l,char *w)
{
  liste parcours;
  liste tmp;
  
  if(*l != NULL)
    {
      parcours = *l;

      if(strcmp(parcours->m,w)==0)
	{
	  tmp=parcours;
	  *l=parcours->suiv;
	  tmp->suiv=NULL;
	  return tmp;
	}
      
      while((parcours->suiv != NULL)
	    &&(strcmp(parcours->suiv->m,w) != 0))
	parcours=parcours->suiv;
      
      if(parcours->suiv == NULL)
	{
	  printf("Le mots n'appartient pas a la liste\n");
	  return NULL;
	}
      
      tmp=parcours->suiv;
      parcours->suiv=parcours->suiv->suiv;
      tmp->suiv=NULL;
      
    }
  return tmp;
}
