#ifndef _PLUGINS_H
#define _PLUGINS_H

#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <dlfcn.h>
#include <dirent.h>
#include <assert.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/param.h>
#include <libgen.h>

#include "pile.h"

typedef struct {
    //! Nom de la fonction
    char * nom; 
    //! Nom du fichier contenant la fonction
    char * fichier; 
    //! Descripteur opaque reprsentant la bibliothque dynamique
    void * handle; 
    //! Fonction
    int (*f)(pile *, int, char **); 
} fonction;

typedef struct {
    //! Tableau des fonctions
    fonction * f; 
    //! Nombre de fonctions enregistrées
    int nbf; 
    //! Nombre de fonctions enregistrables
    int taille_buf; 
} fonctions;

int init_plugins(void);
int ajouter_fonction(char * nom, char * fichier);
int recherche_fonction(char * nom);
int charge_fonction(pile * p, int argc, char ** argv);
int charge_rep(char * nom_rep);
int execute(pile * p, int argc, char ** argv);
int charge_fichier(char * nomfichier);
void tri_fonctions(void);
void effacer_fonctions(void);

#endif /* _PLUGINS_H */
